/// <amd-module name="@typedorm/common/src/decorators/attribute.decorator" />
import 'reflect-metadata';
import { ScalarType } from '../helpers/scalar-type';
import { PrimaryKey } from '../metadata/metadata-storage';
export declare type AttributeOptionsUniqueType = boolean | PrimaryKey;
export interface AttributeOptions {
    /**
     * Item will be managed using transaction to ensure it's consistency
     * When value of unique is of type boolean, entity name is used to auto generated unique prefix
     * @default false
     *
     */
    unique?: AttributeOptionsUniqueType;
    /**
     * Mark property as enum
     * @required when property of type enum is referenced in key
     * @default false
     */
    isEnum?: boolean;
    /**
     * Assign default value to attribute
     */
    default?: ScalarType | (() => ScalarType);
}
export declare function Attribute(options?: AttributeOptions): PropertyDecorator;
